#ifndef __IVF_ARCHIVE_OUTPUT_H__
#define __IVF_ARCHIVE_OUTPUT_H__

#include <Inventor/SoOutput.h>

class CArchive ;
class CFile ;

class IvfArchiveOutput : public SoOutput {
 public:
 	IvfArchiveOutput() ;
 	IvfArchiveOutput(CArchive *ar) ;

	virtual ~IvfArchiveOutput() ;

	CArchive *getArchive() {return m_pAr;} ;

    virtual void		closeFile() ;
    virtual void		flushFile() ;

    virtual void		write(char	     c);
    // C-api: name=writeCharStr
    virtual void		write(const char    *s);
    // C-api: name=writeString
    virtual void		write(const SbString &s);
    // C-api: name=writeName
    virtual void		write(const SbName   &n);
    // C-api: name=writeInt
    virtual void		write(int	     i);
    // C-api: name=writeUInt
    virtual void		write(unsigned int   i);
    // C-api: name=writeShort
    virtual void		write(short	     s);
    // C-api: name=writeUShort
    virtual void		write(unsigned short s);
    // C-api: name=writeLong
    virtual void		write(long	     l);
    // C-api: name=writeULong
    virtual void		write(unsigned long  l);
    // C-api: name=writeFloat
    virtual void		write(float	     f);
    // C-api: name=writeDbl
    virtual void		write(double	     d);
    // C-api: name=writeBinLongArray
    virtual void                writeBinaryArray(long *l, int length);
    // C-api: name=writeBinFloatArray
    virtual void                writeBinaryArray(float *f, int length);
    // C-api: name=writeBinDblArray
    virtual void                writeBinaryArray(double *d, int length);

 private:
 	CArchive *m_pAr ;
	CFile *m_pFile ;
} ;

#endif
